; RefArray subtypes
(set-logic UFLIA)
(declare-fun System.String () Int)
(declare-fun System.Boolean () Int)
(declare-fun Delegate () Int)
(declare-fun System.IntPtr () Int)
(declare-fun MyDelegate () Int)
(declare-fun System.AsyncCallback () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun System.Array () Int)
(declare-fun RefArray (Int Int) Int)
(assert (forall ((?T Int) (?r Int)) (! (subtypes (RefArray ?T ?r) System.Array) :pattern ((RefArray ?T ?r)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ MyDelegate) (= ?U_ MyDelegate)) :pattern ((subtypes ?U_ MyDelegate)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.IntPtr) (= ?U_ System.IntPtr)) :pattern ((subtypes ?U_ System.IntPtr)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.AsyncCallback) (= ?U_ System.AsyncCallback)) :pattern ((subtypes ?U_ System.AsyncCallback)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ Delegate) (= ?U_ Delegate)) :pattern ((subtypes ?U_ Delegate)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.Boolean) (= ?U_ System.Boolean)) :pattern ((subtypes ?U_ System.Boolean)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.String) (= ?U_ System.String)) :pattern ((subtypes ?U_ System.String)))))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)))))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)))))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)))))
(check-sat)
