; Implements subtypes
(set-logic UFLIA)
(declare-fun Microsoft.Contracts.ICheckedException () Int)
(declare-fun Microsoft.Contracts.ObjectInvariantException () Int)
(declare-fun Microsoft.Contracts.GuardException () Int)
(declare-fun System.Exception () Int)
(declare-fun Memory () Int)
(declare-fun System.Array () Int)
(declare-fun System.Object () Int)
(declare-fun System.Runtime.InteropServices._Exception () Int)
(declare-fun Smt.true () Int)
(declare-fun System.Runtime.Serialization.ISerializable () Int)
(declare-fun RTE () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun Implements (Int Int) Int)
(assert (forall ((?T Int) (?J Int)) (! (=> (= (Implements ?T ?J) Smt.true) (subtypes ?T ?J)) :pattern ((Implements ?T ?J)))))
(assert (forall ((?T Int)) (=> (subtypes System.Array ?T) (or (= ?T System.Array) (subtypes System.Object ?T)))))
(assert (forall ((?K Int)) (! (= (subtypes Memory ?K) (or (= Memory ?K) (subtypes System.Object ?K))) :pattern ((subtypes Memory ?K)))))
(assert (forall ((?U Int)) (! (=> (subtypes ?U Memory) (= ?U Memory)) :pattern ((subtypes ?U Memory)))))
(assert (forall ((?K Int)) (! (= (subtypes RTE ?K) (or (= RTE ?K) (subtypes System.Object ?K))) :pattern ((subtypes RTE ?K)))))
(assert (forall ((?K Int)) (! (= (subtypes System.Runtime.Serialization.ISerializable ?K) (or (= System.Runtime.Serialization.ISerializable ?K) (= System.Object ?K))) :pattern ((subtypes System.Runtime.Serialization.ISerializable ?K)))))
(assert (forall ((?K Int)) (! (= (subtypes System.Runtime.InteropServices._Exception ?K) (or (= System.Runtime.InteropServices._Exception ?K) (= System.Object ?K))) :pattern ((subtypes System.Runtime.InteropServices._Exception ?K)))))
(assert (forall ((?K Int)) (! (= (subtypes System.Exception ?K) (or (= System.Exception ?K) (subtypes System.Object ?K) (subtypes System.Runtime.Serialization.ISerializable ?K) (subtypes System.Runtime.InteropServices._Exception ?K))) :pattern ((subtypes System.Exception ?K)))))
(assert (forall ((?K Int)) (! (= (subtypes Microsoft.Contracts.GuardException ?K) (or (= Microsoft.Contracts.GuardException ?K) (subtypes System.Exception ?K))) :pattern ((subtypes Microsoft.Contracts.GuardException ?K)))))
(assert (forall ((?K Int)) (! (= (subtypes Microsoft.Contracts.ObjectInvariantException ?K) (or (= Microsoft.Contracts.ObjectInvariantException ?K) (subtypes Microsoft.Contracts.GuardException ?K))) :pattern ((subtypes Microsoft.Contracts.ObjectInvariantException ?K)))))
(assert (forall ((?K Int)) (! (= (subtypes Microsoft.Contracts.ICheckedException ?K) (or (= Microsoft.Contracts.ICheckedException ?K) (= System.Object ?K))) :pattern ((subtypes Microsoft.Contracts.ICheckedException ?K)))))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)))))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)))))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)))))
(check-sat)
