; array subtypes
(set-logic UFLIA)
(declare-fun T_boolean () Int)
(declare-fun T_char () Int)
(declare-fun T_byte () Int)
(declare-fun array (Int) Int)
(declare-fun T_java.lang.Long () Int)
(declare-fun arrayType () Int)
(declare-fun T_long () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun T_float () Int)
(declare-fun T_java.lang.Double () Int)
(declare-fun T_java.lang.Integer () Int)
(declare-fun T_java.lang.Boolean () Int)
(declare-fun T_java.lang.Float () Int)
(declare-fun T_int () Int)
(declare-fun T_javafe.ast.Identifier () Int)
(declare-fun T_java.lang.String () Int)
(declare-fun T_short () Int)
(declare-fun T_java.lang.Cloneable () Int)
(declare-fun T_double () Int)
(assert (forall ((?t Int)) (! (subtypes (array ?t) arrayType) :pattern ((array ?t)))))
(assert (forall ((?t Int)) (! (subtypes (array ?t) T_java.lang.Cloneable) :pattern ((array ?t)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_java.lang.Long) (= ?t T_java.lang.Long)) :pattern ((subtypes ?t T_java.lang.Long)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_java.lang.Boolean) (= ?t T_java.lang.Boolean)) :pattern ((subtypes ?t T_java.lang.Boolean)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_java.lang.Integer) (= ?t T_java.lang.Integer)) :pattern ((subtypes ?t T_java.lang.Integer)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_java.lang.Double) (= ?t T_java.lang.Double)) :pattern ((subtypes ?t T_java.lang.Double)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_java.lang.Float) (= ?t T_java.lang.Float)) :pattern ((subtypes ?t T_java.lang.Float)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_java.lang.String) (= ?t T_java.lang.String)) :pattern ((subtypes ?t T_java.lang.String)))))
(assert (forall ((?t Int)) (! (= (subtypes ?t T_javafe.ast.Identifier) (= ?t T_javafe.ast.Identifier)) :pattern ((subtypes ?t T_javafe.ast.Identifier)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_double ?t) (= ?t T_double)) :pattern ((subtypes T_double ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_float ?t) (= ?t T_float)) :pattern ((subtypes T_float ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_long ?t) (= ?t T_long)) :pattern ((subtypes T_long ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_int ?t) (= ?t T_int)) :pattern ((subtypes T_int ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_short ?t) (= ?t T_short)) :pattern ((subtypes T_short ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_byte ?t) (= ?t T_byte)) :pattern ((subtypes T_byte ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_char ?t) (= ?t T_char)) :pattern ((subtypes T_char ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes T_boolean ?t) (= ?t T_boolean)) :pattern ((subtypes T_boolean ?t)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_double) (= ?t T_double)) :pattern ((subtypes ?t T_double)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_float) (= ?t T_float)) :pattern ((subtypes ?t T_float)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_long) (= ?t T_long)) :pattern ((subtypes ?t T_long)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_int) (= ?t T_int)) :pattern ((subtypes ?t T_int)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_short) (= ?t T_short)) :pattern ((subtypes ?t T_short)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_byte) (= ?t T_byte)) :pattern ((subtypes ?t T_byte)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_char) (= ?t T_char)) :pattern ((subtypes ?t T_char)))))
(assert (forall ((?t Int)) (! (=> (subtypes ?t T_boolean) (= ?t T_boolean)) :pattern ((subtypes ?t T_boolean)))))
(assert (forall ((?t0 Int) (?t1 Int)) (! (=> (and (subtypes ?t0 ?t1) (subtypes ?t1 ?t0)) (= ?t0 ?t1)) :pattern ((subtypes ?t0 ?t1) (subtypes ?t1 ?t0)))))
(assert (forall ((?t0 Int) (?t1 Int) (?t2 Int)) (! (=> (and (subtypes ?t0 ?t1) (subtypes ?t1 ?t2)) (subtypes ?t0 ?t2)) :pattern ((subtypes ?t0 ?t1) (subtypes ?t1 ?t2)))))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)))))
(check-sat)
