; ValueArray subtypes
(set-logic UFLIA)
(declare-fun System.Double () Int)
(declare-fun test () Int)
(declare-fun System.Boolean () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun System.Single () Int)
(declare-fun System.String () Int)
(declare-fun System.Array () Int)
(declare-fun ValueArray (Int Int) Int)
(assert (forall ((?T Int) (?r Int)) (! (subtypes (ValueArray ?T ?r) System.Array) :pattern ((ValueArray ?T ?r)))))
(assert (forall ((?A Int) (?r Int) (?T Int)) (let ((_let_1 (ValueArray ?A ?r))) (=> (subtypes ?T _let_1) (= ?T _let_1)))))
(assert (forall ((?A Int) (?r Int) (?T Int)) (let ((_let_1 (ValueArray ?A ?r))) (=> (subtypes _let_1 ?T) (or (subtypes System.Array ?T) (= ?T _let_1))))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ test) (= ?U_ test)) :pattern ((subtypes ?U_ test)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.Boolean) (= ?U_ System.Boolean)) :pattern ((subtypes ?U_ System.Boolean)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.String) (= ?U_ System.String)) :pattern ((subtypes ?U_ System.String)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.Double) (= ?U_ System.Double)) :pattern ((subtypes ?U_ System.Double)))))
(assert (forall ((?U_ Int)) (! (=> (subtypes ?U_ System.Single) (= ?U_ System.Single)) :pattern ((subtypes ?U_ System.Single)))))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)))))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)))))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)))))
(check-sat)
